﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading;
using System.IO;
using System.Net;
using System.Net.Sockets;
using System.Windows.Forms;


namespace DemoApplicationEFIS121
{    
    public partial class Form1 : Form
    {
        private EFIS edev = new EFIS(121);
        internal TcpListener Listener;

        public Thread thread_scan;
        private bool thread_scan_cnt;

        public Thread thread_server;
        private bool thread_server_cnt;

        private int control;
        private int status_server;

        private short status;

        public BioUPIC bioupi;

        private byte[] template;

        public UserData[] userdata;
        public TempData[] tempdata;
        public ConRef[]   conref;
        public int num_userdata;
        public int num_tempdata;
        public int num_conref;
        public int cur_userdata;
        public int cur_tempdata;
        public int cur_conref;

        public int retreg;
        public int IDuser;
        ListViewItem itemuser;
        ListViewItem itemref;

        public Form1()
        {
            InitializeComponent();

            status_server = 0;

            bioupi = new BioUPIC(Typeofimages.MBF);
            template = new byte[2048];

            userdata = new UserData[100];
            tempdata = new TempData[100];
            conref   = new ConRef[100];
            num_userdata = 0;
            num_tempdata = 0;
            num_conref   = 0;
            cur_userdata = -1;
            cur_tempdata = -1;
            cur_conref = -1;

            for (int i = 0; i < 100; i++)
            {
                userdata[i] = new UserData();
            }

            for (int i = 0; i < 100; i++)
            {
                tempdata[i] = new TempData();
            }

            for (int i = 0; i < 100; i++)
            {
                conref[i] = new ConRef();
            }
                                  
            //listView1.Bounds = new Rectangle(new Point(10, 10), new Size(300, 200));

            // Set the view to show details.
            listView1.View = View.Details;
            // Allow the user to edit item text.
            //listView1.LabelEdit = true;
            // Allow the user to rearrange columns.
            //listView1.AllowColumnReorder = true;
            // Display check boxes.
            //listView1.CheckBoxes = true;
            // Select the item and subitems when selection is made.
            listView1.FullRowSelect = true;
            // Display grid lines.
            listView1.GridLines = true;
            // Sort the items in the list in ascending order.
            //listView1.Sorting = SortOrder.Ascending;

            /*
            // Create three items and three sets of subitems for each item.
            ListViewItem item1 = new ListViewItem("0");  //("item1", 0);
            // Place a check mark next to the item.
            //item1.Checked = true;            
            item1.SubItems.Add("1");
            item1.SubItems.Add("2");
            item1.SubItems.Add("3");

            listView1.Items.Add(item1);

            ListViewItem item2 = new ListViewItem("item2", 1);
            item2.SubItems.Add("4");
            item2.SubItems.Add("5");
            item2.SubItems.Add("6");
            ListViewItem item3 = new ListViewItem("item3", 0);
            // Place a check mark next to the item.
            item3.Checked = true;
            item3.SubItems.Add("7");
            item3.SubItems.Add("8");
            item3.SubItems.Add("9");
            */
            // Create columns for the items and subitems. 
            // Width of -2 indicates auto-size.
            listView1.Columns.Add("First name", 65, HorizontalAlignment.Center);
            listView1.Columns.Add("Last name", 65, HorizontalAlignment.Center);
            listView1.Columns.Add("Id number", 60, HorizontalAlignment.Center);
            listView1.Columns.Add("Template", -2, HorizontalAlignment.Center);
            
            //Add the items to the ListView.
            //listView1.Items.AddRange(new ListViewItem[] { item1, item2, item3 });

            listViewEREL.View = View.Details;
            listViewEREL.FullRowSelect = true;
            listViewEREL.GridLines = true;

            listViewEREL.Columns.Add("IP Scanner", 95, HorizontalAlignment.Center);
            listViewEREL.Columns.Add("IP Relay", 95, HorizontalAlignment.Center);
            listViewEREL.Columns.Add("Port", 40, HorizontalAlignment.Center);
            listViewEREL.Columns.Add("Delay", -2, HorizontalAlignment.Center);
            listViewEREL.Columns.Add("N", -2, HorizontalAlignment.Center);
          
        }

        private void button1_Click(object sender, EventArgs e)
        {
            control = 0;

            if (edev.OpenDeviceEFIS(textBox1.Text, Convert.ToInt32(textBox2.Text)) >= 0)
            {
                MessageBox.Show("Connect");

                thread_scan = new Thread(this.ScannerRun);
                thread_scan_cnt = true;
                thread_scan.Start();
                button1.Enabled = false;
                button2.Enabled = true;
                button4.Enabled = true;
                button5.Enabled = true;
                button6.Enabled = true;

                textBox8.Text = "Tranning";
            }
            else
            {
                MessageBox.Show("No Connect");
            }

        }

        private void ScannerRun()
        {
            Thread.Sleep(500);
            
            edev.StartupSensor();

            while (thread_scan_cnt)
            {
                if (edev.IsFingerPresentV2() == 0)
                {
                    edev.GetImageV2();                    

                    edev.Show(pictureBox1);

                    if (control == 1)   //  enrollment
                    {
                        retreg = bioupi.CS_CreateTemplate(edev.img.GetPtr(), edev.img.GetWidth(), edev.img.GetHeight(), template, ref status);
                        if (retreg == 1)
                        {
                            MessageBox.Show("Template is created");
                                                        
                            template.CopyTo(tempdata[num_tempdata].temp, 0);
                            tempdata[num_tempdata].flag = 1;
                            tempdata[num_tempdata].ID = IDuser;
                            num_tempdata++;

                            /*
                            int r = CalcTemplates(IDuser);
                            
                            ListViewItem item = listView1.Items[cur_userdata];

                            if (r == 0) item.SubItems[3].Text = "No (" + r.ToString() + ")";
                            else item.SubItems[3].Text = "Yes (" + r.ToString() + ")";
                            */
                            AsyncHandler ah = SomeAsyncMethod;
                            ah.BeginInvoke(null, null);

                            control = 0;
                        }
                    }
                    if (control == 2)   //  identification
                    {
                        int i;
                        bioupi.CS_IdentifyInit(edev.img.GetPtr(), edev.img.GetWidth(), edev.img.GetHeight());

                        for (i = 0; i < num_tempdata; i++)
                        {
                            retreg = bioupi.CS_IdentifyFind(tempdata[i].temp);
                            if (retreg >= 16)
                            {
                                break;
                            }
                        }

                        if (retreg >= 16)
                        {
                            textBox5.Text = "Verified - " + retreg + "  ID user = " + tempdata[i].ID.ToString();
                            edev.LEDRedOFF();
                            edev.LEDGreenTimer(2);
                        }
                        else
                        {
                            textBox5.Text = "No verified";
                            edev.LEDGreenOFF();
                            edev.LEDRedTimer(1);
                        }
                    }                
                    edev.StartupSensor();   /* don't forget to call this function again after efisGetImage*/ 
                }              
            }
        }

        private delegate void AsyncHandler();

        private void SomeAsyncMethod()
        {
            if (listView1.InvokeRequired)
            {
                listView1.Invoke(new AsyncHandler(AddItem));
            }
            else
            {
                AddItem();
            }
        }

        private void AddItem()
        {
            int r = CalcTemplates(IDuser);

            ListViewItem item = listView1.Items[cur_userdata];

            if (r == 0) item.SubItems[3].Text = "No (" + r.ToString() + ")";
            else item.SubItems[3].Text = "Yes (" + r.ToString() + ")";
        }



  

        private int	CalcTemplates(int _id)
        {
            int	i, ret = 0;

            for(i = 0; i < num_tempdata; i++) {
	            if ( tempdata[i].ID == _id )	ret++;
            }
            return	ret;
        }
        
        public void TcpServerStart()
        {
            int len;
            len = textBox3.Text.LastIndexOf('\r');
            if (len != -1)
            {
                String sss = textBox3.Text.Remove(len);
                IPAddress ip = IPAddress.Parse(sss);

                Listener = new TcpListener(ip, Convert.ToInt32(textBox4.Text));
            }
            else 
            {
                IPAddress ip = IPAddress.Parse(textBox3.Text);

                Listener = new TcpListener(ip, Convert.ToInt32(textBox4.Text));
            }
            Listener.Start();
 
            while (thread_server_cnt)
            {
                TcpClient tcpc = Listener.AcceptTcpClient();

                ParamObjs objs = new ParamObjs(this, tcpc);

                Thread Thread = new Thread(new ParameterizedThreadStart(ClientThread));
                Thread.Start(objs);                                              
            }
        }

        static void ClientThread(Object StateInfo)
        {
            new Client((ParamObjs)StateInfo);
        } 
        
        public void TcpServerStop()
        {
            if (Listener != null)
            {
                Listener.Stop();
            }
        }

        
        private void button2_Click(object sender, EventArgs e)
        {
            thread_scan_cnt = false;
            thread_scan.Abort();
            edev.CloseDevice();

            button1.Enabled = true;
            button2.Enabled = false;
            button4.Enabled = false;
            button5.Enabled = false;
            button6.Enabled = false;
            textBox8.Text = "";
        }

        private void button4_Click(object sender, EventArgs e)
        {
            textBox8.Text = "Tranning";
            control = 0;
        }

        //  Enrollment
        private void button5_Click(object sender, EventArgs e)
        {
            if (cur_userdata == -1)
            {
                MessageBox.Show("The user isn't selected", "Enrollment");
                return;
            }
            ListViewItem item = listView1.Items[cur_userdata];

            if (item.Selected == false)
            {
                MessageBox.Show("The user isn't selected", "Enrollment");
                return;
            }

            textBox8.Text = "Enrollment";
            control = 1;
            status = 0;
        }

        private void button6_Click(object sender, EventArgs e)
        {
            textBox8.Text = "identification";
            control = 2;
        }

        private void button3_Click(object sender, EventArgs e)  //  Server
        {
            if (status_server == 0)
            {
                thread_server_cnt = true;
                status_server = 1;
                button3.Text = "Server (Active)";
                
                thread_server = new Thread(TcpServerStart);
                thread_server_cnt = true;
                thread_server.Start();

            }
            else
            {
                status_server = 0;
                button3.Text = "Server (No active)";

                thread_server_cnt = false;
                thread_server.Abort();

                TcpServerStop();

            }
        }
        //  modify user
        private void button8_Click(object sender, EventArgs e)
        {
            if (cur_userdata != -1)
            {
                ASCIIEncoding encoding = new ASCIIEncoding();
                encoding.GetBytes(textBox6.Text).CopyTo(userdata[cur_userdata].fname,0);
                encoding.GetBytes(textBox7.Text).CopyTo(userdata[cur_userdata].lname,0);

                ListViewItem item = listView1.Items[cur_userdata];

                item.SubItems[0].Text = textBox6.Text;
                item.SubItems[1].Text = textBox7.Text;
            }

        }
        //  add new user
        private void button7_Click(object sender, EventArgs e)
        {
            int i, j, stat;

            //  find free ID number
            for (i = 1; i < 101; i++)
            {
                stat = 0;
                for (j = 0; j < num_userdata ; j++)
                {
                    if ( userdata[j].ID == i) { stat = 1; break; }
                }
                if ( stat == 0)
                {
                    userdata[num_userdata].ID = i;
                    break;
                }
            }

            ASCIIEncoding encoding = new ASCIIEncoding();
            encoding.GetBytes(textBox6.Text).CopyTo(userdata[num_userdata].fname,0);
            encoding.GetBytes(textBox7.Text).CopyTo(userdata[num_userdata].lname,0);

            ListViewItem item1 = new ListViewItem(textBox6.Text);
            // Place a check mark next to the item.
            item1.SubItems.Add(textBox7.Text);
            item1.SubItems.Add(userdata[num_userdata].ID.ToString());
            item1.SubItems.Add("No");

            listView1.Items.Add(item1);
            
            num_userdata++;
        }

        private void listview1_Click(object sender, EventArgs e)
        {
            cur_userdata = listView1.FocusedItem.Index;

            itemuser = listView1.Items[cur_userdata];

            textBox6.Text = itemuser.SubItems[0].Text;
            textBox7.Text = itemuser.SubItems[1].Text;

            IDuser = Convert.ToInt32(itemuser.SubItems[2].Text);

        }

        private void listViewEREL_Click(object sender, EventArgs e)
        {
            cur_conref = listViewEREL.FocusedItem.Index;

            itemref = listViewEREL.Items[cur_conref];

            textBoxIPscanner.Text = itemref.SubItems[0].Text;
            textBoxIPEREL.Text = itemref.SubItems[1].Text;

            textBoxERELPort.Text = itemref.SubItems[2].Text;
            textBoxDelay.Text = itemref.SubItems[3].Text;
            textBoxNContact.Text = itemref.SubItems[4].Text;
        }

        
        //  delete user
        private void button9_Click(object sender, EventArgs e)
        {            
            if (cur_userdata != -1)
            {
                ListViewItem item = listView1.Items[cur_userdata];

                if (item.Selected == true)
                {
                    int id = Convert.ToInt32(item.SubItems[2].Text);

                    for (int i = cur_userdata; i < (num_userdata - 1); i++)
                    {
                        userdata[i + 1].CopyTo(userdata[i]);
                    }

                    item.Remove();
                    num_userdata--;

                    Deletetmp(id);
                    cur_userdata = -1;
                }
            }

        }
        //  delete of template
        private void Deletetmp(int _id)
        {
            int	i, j;

            for(i = 0; i < num_tempdata; i++) {
	            if ( tempdata[i].ID == _id ) {
		           for(j = i; j < (num_tempdata-1); j++) {
                       tempdata[j + 1].CopyTo(tempdata[j]);
		            }
		            num_tempdata--;
	            }
            }
        }

        private void LoadFromFile_Click(object sender, EventArgs e)
        {

            DialogResult result = MessageBox.Show("Do you want to load the users and templates?", "Users and templates", MessageBoxButtons.YesNo);

            if (result == DialogResult.No)
            {
                return;
            }
                        
            byte[] buff = new byte[16];
            
            //  load users
            FileInfo info = new FileInfo("@userdat.bin");
            int i, size = (int)info.Length;

            num_userdata = size / (32 + 32 + 4);
                        
            FileStream inStream = File.Open("@userdat.bin", FileMode.Open, FileAccess.Read, FileShare.Read);
            
            for (i = 0; i < num_userdata; i++)
            {
                inStream.Read(userdata[i].fname, 0, 32);
                inStream.Read(userdata[i].lname, 0, 32);
                inStream.Read(buff, 0, 4);
                userdata[i].ID = BitConverter.ToInt32(buff, 0);                
            }
            inStream.Close();

            //  load templates
            FileInfo info1 = new FileInfo("@tempdat.bin");
            size = (int)info1.Length;

            num_tempdata = size / (4 + 1 + 2048);

            FileStream inStream1 = File.Open("@tempdat.bin", FileMode.Open, FileAccess.Read, FileShare.Read);

            for (i = 0; i < num_tempdata; i++)
            {
                inStream1.Read(buff, 0, 4);
                tempdata[i].ID = BitConverter.ToInt32(buff, 0);

                inStream1.Read(buff, 0, 1);
                tempdata[i].flag = (byte)BitConverter.ToChar(buff, 0);
                
                inStream1.Read(tempdata[i].temp, 0, 2048);
            }
            inStream1.Close();
            
            listView1.Clear();

            listView1.Columns.Add("First name", 65, HorizontalAlignment.Center);
            listView1.Columns.Add("Last name", 65, HorizontalAlignment.Center);
            listView1.Columns.Add("Id number", 60, HorizontalAlignment.Center);
            listView1.Columns.Add("Template", -2, HorizontalAlignment.Center);

            for (i = 0; i < num_userdata; i++)
            {
                ListViewItem item1 = new ListViewItem(System.Text.ASCIIEncoding.ASCII.GetString(userdata[i].fname));
                item1.SubItems.Add(System.Text.ASCIIEncoding.ASCII.GetString(userdata[i].lname));
                item1.SubItems.Add(userdata[i].ID.ToString());

                int r = CalcTemplates(userdata[i].ID);

                if (r == 0) item1.SubItems.Add("No (" + r.ToString() + ")");
                else        item1.SubItems.Add("Yes (" + r.ToString() + ")");

                listView1.Items.Add(item1);
            }

            num_tempdata = size / (4 + 1 + 2048);

            //  load erel info
            FileInfo info2 = new FileInfo("@ereldat.bin");
            size = (int)info2.Length;

            num_conref = size / (17 + 17 + 2 + 1 + 1);

            FileStream inStream2 = File.Open("@ereldat.bin", FileMode.Open, FileAccess.Read, FileShare.Read);

            for (i = 0; i < num_conref; i++)
            {
                inStream2.Read(conref[i].ipscn, 0, 17);
                inStream2.Read(conref[i].iprel, 0, 17);

                inStream2.Read(buff, 0, 2);
                conref[i].prrel = BitConverter.ToInt16(buff, 0);

                inStream2.Read(buff, 0, 1);
                conref[i].delay = (byte)BitConverter.ToChar(buff, 0);

                inStream2.Read(buff, 0, 1);
                conref[i].relcontact = (byte)BitConverter.ToChar(buff, 0);                
            }
            inStream2.Close();

            listViewEREL.Clear();

            listViewEREL.Columns.Add("IP Scanner", 95, HorizontalAlignment.Center);
            listViewEREL.Columns.Add("IP Relay", 95, HorizontalAlignment.Center);
            listViewEREL.Columns.Add("Port", 40, HorizontalAlignment.Center);
            listViewEREL.Columns.Add("Delay", -2, HorizontalAlignment.Center);
            listViewEREL.Columns.Add("N", -2, HorizontalAlignment.Center);

            for (i = 0; i < num_conref; i++)
            {
                ListViewItem item2 = new ListViewItem(System.Text.ASCIIEncoding.ASCII.GetString(conref[i].ipscn));
                item2.SubItems.Add(System.Text.ASCIIEncoding.ASCII.GetString(conref[i].iprel));
                item2.SubItems.Add(conref[i].prrel.ToString());
                item2.SubItems.Add(conref[i].delay.ToString());
                item2.SubItems.Add(conref[i].relcontact.ToString());

                listViewEREL.Items.Add(item2);
            }
           
        }
       
        private void SaveToFile_Click(object sender, EventArgs e)
        {
            int i;

            DialogResult result = MessageBox.Show("Do you want to save the users and templates?", "Users and templates", MessageBoxButtons.YesNo);

            if (result == DialogResult.No)
            {
                return;
            }

            //using (FileStream inStream = File.Open(sourceFile, FileMode.Open, FileAccess.Read, FileShare.Read))
            FileStream outStream = File.Open("@userdat.bin", FileMode.Create, FileAccess.Write, FileShare.None);

            for(i = 0; i < num_userdata; i++) 
            {
                outStream.Write(userdata[i].fname, 0, 32);    
                outStream.Write(userdata[i].lname, 0, 32);
                byte[] buff = BitConverter.GetBytes(userdata[i].ID);                
                outStream.Write(buff, 0, 4);
            }
            outStream.Close();

            FileStream outStream1 = File.Open("@tempdat.bin", FileMode.Create, FileAccess.Write, FileShare.None);

            for (i = 0; i < num_tempdata; i++)
            {
                byte[] buff1 = BitConverter.GetBytes(tempdata[i].ID);
                outStream1.Write(buff1, 0, 4);

                byte[] buff2 = BitConverter.GetBytes(tempdata[i].flag);
                outStream1.Write(buff2, 0, 1);

                outStream1.Write(tempdata[i].temp, 0, 2048);
            }
            outStream1.Close();


            FileStream outStream2 = File.Open("@ereldat.bin", FileMode.Create, FileAccess.Write, FileShare.None);

            for (i = 0; i < num_conref; i++)
            {
                outStream2.Write(conref[i].ipscn, 0, 17);
                outStream2.Write(conref[i].iprel, 0, 17);
                byte[] buff3 = BitConverter.GetBytes(conref[i].prrel);
                outStream2.Write(buff3, 0, 2);
                byte[] buff4 = BitConverter.GetBytes(conref[i].delay);
                outStream2.Write(buff4, 0, 1);
                byte[] buff5 = BitConverter.GetBytes(conref[i].relcontact);
                outStream2.Write(buff5, 0, 1);
            }
            outStream2.Close();              
        }

        private void Exit_Click(object sender, EventArgs e)
        {
            Application.Exit();
        }

        private void Form1_Load(object sender, EventArgs e)
        {

        }

        private void buttonAdd_Click(object sender, EventArgs e)
        {
            ASCIIEncoding encoding = new ASCIIEncoding();
            encoding.GetBytes(textBoxIPscanner.Text).CopyTo(conref[num_conref].ipscn, 0);
            encoding.GetBytes(textBoxIPEREL.Text).CopyTo(conref[num_conref].iprel, 0);

            conref[num_conref].prrel = Convert.ToInt16(textBoxERELPort.Text);
            conref[num_conref].delay = Convert.ToByte(textBoxDelay.Text);
            conref[num_conref].relcontact = Convert.ToByte(textBoxNContact.Text);
            
            ListViewItem item1 = new ListViewItem(textBoxIPscanner.Text);
            // Place a check mark next to the item.
            item1.SubItems.Add(textBoxIPEREL.Text);
            item1.SubItems.Add(conref[num_conref].prrel.ToString());
            item1.SubItems.Add(conref[num_conref].delay.ToString());
            item1.SubItems.Add(conref[num_conref].relcontact.ToString());
            

            listViewEREL.Items.Add(item1);

            num_conref++;
        }

        private void buttonDelete_Click(object sender, EventArgs e)
        {
            if (cur_conref != -1)
            {
                ListViewItem item = listViewEREL.Items[cur_conref];

                if (item.Selected == true)
                {
                    for (int i = cur_conref; i < (num_conref - 1); i++)
                    {
                        conref[i + 1].CopyTo(conref[i]);
                    }

                    item.Remove();
                    num_conref--;
                }
                cur_conref = -1;
            }
        }
    }

    public class ParamObjs
    {
        public Form1 form;
        public TcpClient tcpc;

        public ParamObjs()
        {
        }

        public ParamObjs(Form1 _form, TcpClient _tcpc)
        {
            form = _form;
            tcpc = _tcpc;
        }
    }
}
  
