﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Net;
using System.Net.Sockets;
using System.Text;

namespace DemoApplicationEFIS121
{
    
    class Client
    {

        ParamObjs objs;
        EREL erel;

        public Client(ParamObjs _objs)
        {
            int i, retreg = 0;
            EFIS scanner = new EFIS(121);
            
            erel = new EREL();
            objs = new ParamObjs(_objs.form,_objs.tcpc);

            scanner.OpenDevicebySocket(objs.tcpc.Client);

            while (true)
            {
                if (scanner.IsFingerPresentV2() == 0)
                {
                    scanner.GetImageV2();
                    scanner.StartupSensor();

                    scanner.Show(objs.form.pictureBox1);

                    objs.form.bioupi.CS_IdentifyInit(scanner.img.GetPtr(), scanner.img.GetWidth(), scanner.img.GetHeight());

                    for (i = 0; i < objs.form.num_tempdata; i++)
                    {
                        retreg = objs.form.bioupi.CS_IdentifyFind(objs.form.tempdata[i].temp);
                        if (retreg >= 16)
                        {
                            break;
                        }
                    }

                    if (retreg >= 16)
                    {
                        string addr = objs.tcpc.Client.RemoteEndPoint.ToString();        

                        objs.form.textBox5.Text = "Verified - " + retreg + "  ID user = " + objs.form.tempdata[i].ID.ToString();
                        scanner.LEDRedOFF();
                        scanner.LEDGreenTimer(2);

                        ControlErel(addr);

                        break;
                    }
                    else
                    {                        
                        objs.form.textBox5.Text = "No verified";
                        scanner.LEDGreenOFF();
                        scanner.LEDRedTimer(1);
                        break;
                    }
                }
                else
                {
                    break;
                }
            }

            objs.tcpc.Close();            
        }

        public int ControlErel(string addr)
        {
            byte[] baddr = new byte[32];            
            int len = addr.LastIndexOf(':');
            ASCIIEncoding encoding = new ASCIIEncoding();
            encoding.GetBytes(addr).CopyTo(baddr, 0);
            baddr[len] = 0;

            for (int i = 0; i < objs.form.num_conref; i++)
            {
                bool comp = objs.form.conref[i].CompIPScan(baddr);
                if (comp == true)
                {
                    erel.CS_OpenDevice(objs.form.conref[i].iprel, objs.form.conref[i].prrel);
                    erel.CS_RelayOnTimer((byte)(1 << (objs.form.conref[i].relcontact - 1)), objs.form.conref[i].delay);
                    erel.CS_CloseDevice();
                }
            }
            return 1;
        }


    }
}
