﻿using System;
using System.Runtime.InteropServices;
using System.Text;
using System.Windows.Forms;
using System.Drawing;
using System.Net;
using System.Net.Sockets;
using System.Threading;


namespace DemoApplicationEFIS121
{
    class EREL
    {
        private int _hndl;
        Socket socket;

        private int hndl
        {
            get { return _hndl; }
            set { _hndl = value; }
        }

        [DllImport("erel11xc.dll")]
        public static extern int erelOpenDevice(int typedevice, byte[] addr, int port);

        [DllImport("erel11xc.dll")]
        public static extern int erelCloseDevice(int handle);
            
        [DllImport("erel11xc.dll")]
        public static extern void erelSetOpenTimeout(int timeout);

        [DllImport("erel11xc.dll")]
        public static extern int erelRelayOn(int handle, byte nRelay);

        [DllImport("erel11xc.dll")]
        public static extern int erelRelayOff(int handle, byte nRelay);

        [DllImport("erel11xc.dll")]
        public static extern int erelRelayOnTimer(int handle, byte nRelay, byte nTime);
        
        public EREL()
        {
            _hndl = -1;
        }

        public int OpenDeviceEREL(string addr, int port)
        {
            byte[] baddr = new byte[32];

            ASCIIEncoding encoding = new ASCIIEncoding();
            baddr = encoding.GetBytes(addr);

            hndl = erelOpenDevice(112, baddr, port);

            return hndl;
        }

        public int OpenDeviceEREL(byte [] addr, int port)
        {
            hndl = erelOpenDevice(112, addr, port);

            return hndl;
        }

        public int CloseDevice()
        {
            if ( hndl >= 0 )    erelCloseDevice(hndl);

            return hndl;
        }

        public void SetOpenTimeout(int timeout)
        {
            erelSetOpenTimeout(timeout);
        }

        public int RelayOnTimer(byte nRelay, byte nTime)
        {
            return erelRelayOnTimer(hndl, nRelay, nTime);
        }

        public int RelayOn(byte nRelay)
        {
            return erelRelayOn(hndl, nRelay);
        }

        public int RelayOff(byte nRelay)
        {
            return erelRelayOff(hndl, nRelay);
        }



        public Socket CS_OpenDevice(byte[] addr, int port)
        {
            socket = new Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp);
            IPAddress ip;
            String aa = System.Text.ASCIIEncoding.ASCII.GetString(addr);
            int len = aa.IndexOf('\0');
            if (len != -1)
            {
                String sss = aa.Remove(len);

                ip = IPAddress.Parse(sss);
            }
            else
            {
                ip = IPAddress.Parse(aa);
            }
                       
            socket.Connect(ip, port);
            if (socket.Connected == true) return socket;

            return  null;
        }

        public void CS_CloseDevice()
        {
            if (socket.Connected == true) 
            {
                socket.Close();
            }
        }

        public int CS_RelayOnTimer(byte nRelay, byte nTime)
        {
            byte[] buf = new byte[3];

            buf[0] = (byte)'E';
            buf[1] = nRelay;
            buf[2] = nTime;

            if (socket.Connected == true) 
            {
                socket.Send(buf);
                socket.Receive(buf);    //  answer
            }

            return 0;
        }

    }
}
