﻿using System;

namespace DemoApplicationEFIS121
{

    public class UserData
    {
        public int ID;
        public byte[] fname;
        public byte[] lname;

        public UserData()
        {
            fname = new byte[32];
            lname = new byte[32];
            
            ID = 0;
        }

        public UserData(byte[] _f, byte[] _l, int _id)
        {
            fname = new byte[32];
            lname = new byte[32];

            fname = _f;
            lname = _l;
            ID = _id;
        }

        public void CopyTo(UserData _dsc)
        {
            _dsc.ID = ID;
            fname.CopyTo(_dsc.fname,0);
            lname.CopyTo(_dsc.lname,0);
        }
    }

    public class TempData
    {
        public int ID;
        public byte flag;
        public byte[] temp;

        public TempData()
        {
            temp = new byte[2048];
            ID = 0;
        }

        public TempData(byte[] _t, byte _flag, int _id)
        {
            temp = new byte[2048];

            temp = _t;
            flag = _flag;
            ID = _id;
        }
        public void CopyTo(TempData _dsc)
        {
            _dsc.ID = ID;
            _dsc.flag = flag;
            temp.CopyTo(_dsc.temp,0);
        }
    }

    public class ConRef
    {
        public byte [] ipscn;
        public byte [] iprel;
        public short prrel;
        public byte delay;
        public byte relcontact;

        public ConRef()
        {
            ipscn = new byte[17];
            iprel = new byte[17];
            prrel = 0;
            delay = 0;
            relcontact = 0;            
        }

        public void CopyTo(ConRef _dsc)
        {
            ipscn.CopyTo(_dsc.ipscn, 0);
            iprel.CopyTo(_dsc.iprel, 0);
            _dsc.prrel = prrel;
            _dsc.delay = delay;
            _dsc.relcontact = relcontact;
        }

        public bool CompIPScan(byte[] _addr)
        {
            int i, stat;

            stat = 0;

            for (i = 0; i < 17; i++)
            {
                if (ipscn[i] != _addr[i]) { stat = 1; break; }
                if (ipscn[i] == 0) break;
                if (_addr[i] == 0) break;
            }
            if (stat == 0) return true;

            return false;
        }


    }

        

}